#outputscript
import CapacityResource as CapRes
import BelongToArmyResource2 as BTAR2
import BelongToSuperResource2 as BTSR2
import subresourcetypedict as SBTD
import CapacityRequirement as CapReq
import Ttravel
import DistanceMatrix
import Tasks

from ruamel import yaml

filename ="test_gen_inputdata.yaml"

with open(filename, 'r') as file:
   read_data = yaml.load(file, Loader=yaml.Loader)

   Code =read_data['Code']
   Instance = read_data['Instance']

   nSR = read_data['nSR']
   nTasks = read_data['nTasks']
   nDuplicates = read_data['nDuplicates']
   nLoc = read_data['nLoc']
   nEndTime = read_data['nEndTime']
   nSkills = read_data['nSkills']
   nSkillLevels = read_data['nSkillLevels']
   ttask_min = read_data['ttask_min']
   capres_max_pntg = read_data['capres_max_pntg']
   con_pntg = read_data['con_pntg']
   dir_pntg = read_data['dir_pntg']
   div_pntg = read_data['div_pntg']
   exc_pntg = read_data['exc_pntg']
   long_pntg = read_data['long_pntg']
   tmin_pntg = read_data['tmin_pntg']
   prec_pntg = read_data['prec_pntg']
   maxtaskprec = read_data['maxtaskprec']
   maxtaskdir = read_data['maxtaskdir']
   maxtaskcon = read_data['maxtaskcon']
   pSuff = read_data['pSuff']
   nSkillsLow = read_data['nSkillsLow']
   nSkillsMedium = read_data['nSkillsHigh']
   nSkillsHigh = read_data['nSkillsHigh']
   capreq_min = read_data['capreq_min']
   capreq_max = read_data['capreq_max']
   nSkillsMin = read_data['nSkillsMin']
   nSkillsMax = read_data['nSkillsMax']
   capPerSkillMin = read_data['capPerSkillMin']
   capPerSkillMax = read_data['capPerSkillMax']
   value_max = read_data['value_max']
   nResourcesPerTask = read_data['nResourcesPerTask']

bgt = eval(open("battlegrouptypes.txt").read())
bg = eval(open("battlegroup.txt").read())
pointdata = eval(open("locations_fixed.txt").read())
rsd = eval(open("resourceskills.txt").read())
ges = eval(open("skilllevel_sb_skill.txt").read())
nSubResources =bg[nSR][len(bg[nSR])-1]

#call functions
DistanceM = DistanceMatrix.DistPnt(pointdata, nLoc)
SBtypedict= SBTD.SBtypedict(bgt,bg)

BTAR = BTAR2.BTAR2fnc(bgt,nSR)
BTSR = BTSR2.BTSR2fnc(bgt,nSR)
Ttravel = Ttravel.Ttravelfnc(nSR, BTAR, pointdata, nLoc)
BelongToTaskSleep,BelongToTaskDuplicate,BelongToTaskLong, BelongToTaskRest, BelongToTaskExclusive, BelongToTaskDivisible, Tmin, Capmax, BelongToLocation, Ttask, ReleaseTime, Deadline, MaximumVisits, nVisits, Value, Precedence, Connected, DirectStart, preccounter, concounter, dircounter, rescounter = Tasks.Tasksgen(nTasks, nDuplicates, nEndTime, nLoc, nSkillLevels, long_pntg, tmin_pntg, capres_max_pntg, exc_pntg, div_pntg, prec_pntg, con_pntg, dir_pntg, value_max, ttask_min, DistanceM, maxtaskprec, maxtaskcon, maxtaskdir)
CapacityResource = CapRes.CapResfnc(nSR,nSkills,nSkillLevels,SBtypedict, ges, rsd,bg)
CapacityRequirement = CapReq.CapacityRequirement(nSkills, nSkillsLow, nSkillsMedium, nSkillsHigh, capreq_min, capreq_max, nSkillsMin, nSkillsMax, capPerSkillMin, capPerSkillMax, nTasks, nDuplicates, BelongToTaskSleep, BelongToTaskRest, BelongToTaskDuplicate, nSubResources)
TaskSkills = CapReq.taskSkills(CapacityRequirement)

#write to file
output_filename = './test_instances/'+Code+'_'+ "nSR_"+str(nSR)+"_nTasks_"+str(nTasks)+ '_' +"nLoc_"+str(nLoc)+'_'+str(Instance)+'.txt'

with open(output_filename, "w") as file:
   file.write('!'+Code+'_'+ "nSR_"+str(nSR)+"_nTasks_"+str(nTasks)+ '_' +"nLoc_"+str(nLoc)+'_'+str(Instance)+'.txt' +'\n')
   file.write('' + '\n')
   file.write('nSuperResources:     ' + str(nSR)+ "\n")
   file.write('nSubResources:       ' + str(nSubResources)+ "\n")
   file.write('nTasks:              ' + str(nTasks)+ "\n")
   file.write('nDuplicates:         ' + str(nDuplicates)+ "\n")
   file.write('nLocations:          ' + str(nLoc)+ "\n")
   file.write('nSkills:             ' + str(nSkills)+ "\n")
   file.write('nSkillLevels:        ' + (str(nSkillLevels))+ "\n")
   file.write('nEndTime:            ' + (str(nEndTime))+ "\n")
   file.write('nVisits:             ' + (str(nVisits))+ "\n")
   file.write('nResourcesPerTask:   ' + str(nResourcesPerTask)+ "\n")
   file.write(''+ "\n")

   file.write('MaximumVisits:               [')
   for item in MaximumVisits:
      file.write(str(item) + ' ')
   file.write(']'+'\n')
   file.write(''+ "\n")
   file.write('BelongToSuperResource:       [')
   for item in BTSR:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('BelongToArmySuperResource:   [')
   for item in BTAR:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write(''+ "\n")
   file.write('BelongToTaskDuplicate:       [')
   for item in BelongToTaskDuplicate:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('BelongToTaskSleep:           [')
   for item in BelongToTaskSleep:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('BelongToTaskLong:            [')
   for item in BelongToTaskLong:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('BelongToTaskRest:            [')
   for item in BelongToTaskRest:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('BelongToTaskExclusive:       [')
   for item in BelongToTaskExclusive:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('BelongToTaskDivisible:       [')
   for item in BelongToTaskDivisible:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('Tmin:                        [')
   for item in Tmin:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('CapacityMaximum:             [')
   for item in Capmax:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('BelongToLocation:            [')
   for item in BelongToLocation:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('Ttask:                       [')
   for item in Ttask:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('ReleaseTime:                 [')
   for item in ReleaseTime:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('Deadline:                    [')
   for item in Deadline:
      file.write(str(item) + ' ')
   file.write(']' + '\n')
   file.write('' + '\n')

   file.write('!#Rest tasks: ' + str(rescounter)+'\n')
   file.write('!#Precedence: ' + str(preccounter)+'\n')
   file.write('!#Connected tasks: ' + str(concounter) + '\n')
   file.write('!#Directstart tasks: ' + str(dircounter)+'\n')
   file.write('Precedence: ['+ "\n")
   for list in Precedence:
      for item in list[:-1]:
         file.write(str(item) + " ")
      item = list[-1]
      file.write(str(item) + "\n")
   file.write(']'+ "\n")
   file.write(''+ "\n")
   file.write('Connected: ['+ "\n")
   for list in Connected:
      for item in list[:-1]:
         file.write(str(item)+ " ")
      item = list[-1]
      file.write(str(item)+ "\n")
   file.write(']'+ "\n")
   file.write(''+ "\n")
   file.write('DirectStart: ['+ "\n")
   for list in DirectStart:
      for item in list[:-1]:
         file.write(str(item)+ " ")
      item = list[-1]
      file.write(str(item)+ "\n")
   file.write(']'+ "\n")
   file.write(''+ "\n")
   file.write('Value: ['+ "\n")
   for list in Value:
      for item in list[:-1]:
         file.write(str(item)+ " ")
      item = list[-1]
      file.write(str(item)+ "\n")
   file.write(']'+ "\n")
   file.write(''+ "\n")
   file.write('CapacityRequirement: ['+ "\n")
   for task in CapacityRequirement:
      for skill in task[:-1]:
         file.write(str(skill)+ " ")
      skill = task[-1]
      file.write(str(skill)+ "\n")
   file.write(']'+ "\n")
   file.write(''+ "\n")
   file.write('TaskSkills: ['+ "\n")
   for task in TaskSkills:
      for skill in task[:-1]:
         file.write(str(skill)+ " ")
      skill = task[-1]
      file.write(str(skill)+ "\n")
   file.write(']'+ "\n")
   file.write(''+ "\n")
   file.write('CapacityResource: ['+ "\n")
   for subresource in CapacityResource:
      for list in subresource:
         for item in list[:-1]:
            file.write(str(item)+ " ")
         item = list[-1]
         file.write(str(item)+ "\n")
      file.write(''+ "\n")
   file.write(']'+ "\n")
   file.write(''+ "\n")
   file.write('Ttravel: ['+ "\n")
   for superresource in Ttravel:
      for list in superresource:
         for item in list[:-1]:
            file.write(str(item)+ " ")
         item = list[-1]
         file.write(str(item)+ "\n")
      file.write(''+ "\n")
   file.write(']'+ "\n")
